import { Language, LanguageSupport, LRLanguage } from '@codemirror/language';
import { Parser, NodeSet, NodePropSource, Input, TreeFragment, PartialParse } from '@lezer/common';

declare class PGMLParser extends Parser {
    nodeTypes: Record<string, number>;
    readonly nodeSet: NodeSet;
    constructor(props?: NodePropSource[]);
    createParse(input: Input, fragments: readonly TreeFragment[], ranges: readonly {
        from: number;
        to: number;
    }[]): PartialParse;
    getNodeType(name: string): number;
}

declare class PGTextParser extends Parser {
    nodeTypes: Record<string, number>;
    readonly nodeSet: NodeSet;
    constructor(props?: NodePropSource[]);
    createParse(input: Input, fragments: readonly TreeFragment[], ranges: readonly {
        from: number;
        to: number;
    }[]): PartialParse;
    getNodeType(name: string): number;
}

declare const pgmlShow: (input: string) => string;

declare const pgmlParser: PGMLParser;
declare const pgmlLanguage: Language;
declare const pgml: () => LanguageSupport;
declare const pgTextParser: PGTextParser;
declare const pgTextLanguage: Language;
declare const pgText: () => LanguageSupport;
declare const pgLanguage: LRLanguage;
declare const pg: () => LanguageSupport;

export { pg, pgLanguage, pgText, pgTextLanguage, pgTextParser, pgml, pgmlLanguage, pgmlParser, pgmlShow };
